
	TTL 'TESTS'

	XREF INITUV,POST,POST2,ROLL,PITCH,YAW,CONCAT,PRESUB,TPROJ
	XREF TANK,CUBE,ROCKET,AIR,SAUCER,BUZZ,FLM,SQ,BOX,TSQ,HIND,CITY,STARS
	XREF VGHALT,CENTER,INIT,INITB,INIT320
	XREF D2_CUBE,D2_SQ,D2_TANK,D2_ROC,D2_AIR,D2_SAU,D2_BUZZ,D2_HIND,D2_CITY
	XREF VGOVER,HUD,HEADING,ALTITUDE,AIRSPEED,VWTHRUST,HORIZ
	XREF VWHEX,FLY,FLY1,FLY2,VWBYTE,VWWORD
	XREF ROTATE,ROTATE1,ROTATE2,WC_GEN
	XREF HORIZ,RUNWAY,T_ROLL,T_PTCH,T_YAW
	XREF VJ_BKBOX,VJ_SITE,VJ_TITL,VJ_THRUST,VJ_HDN,VJ_ZOOM,VGIMAGE,VGANLOC
	XREF VW_1D,VW_2D,VW_3D,VW_4D
	XREF TERR,VASI,LIGHTS,GUNS,PDOT
	XREF GRID,GRLINE


	INCLUDE 'COMN.ASM'

	XDEF VGDATA,VG1,VG2,VG3,VG4,VG5,VG6,VG7,VG8,VG9,VG10
	XDEF VWAIT,VWAIT2,VANUP,UP,DOWN320

	XDEF TEST1,TEST2,TEST3,TEST4,TEST5,TEST6,TEST7,DONE7,TEST8,DONE8
	XDEF TEST9,DONE9,TEST10,DONE10
	XDEF TEST12,DONE12,TEST13,DONE13,TEST14,DONE14,TEST15,DONE15
	XDEF TEST16,DONE16,TEST17,DONE17,TEST18,DONE18,TEST19,DONE19
	XDEF TEST20,DONE20,TEST21,DONE21,TEST22,DONE22

	XDEF RT1,RT2,RT3,PTERR
	XDEF POTS,SW,TROTATE

	SECTION	PROGRAM
*--------------------------------------------------------
	PAGE	
* VG ADDRESSES (TO BE MODIFIED BY POTS)
*
VGADR1	EQU 	VMEM+$001F	*Y OF POINT	
VGADR2	EQU	VMEM+$0021	*X OF POINT
VGADR3	EQU	VMEM+$0001	*LINEAR SCALE
VGADR4	EQU	VMEM+$0003	*ZSTAT BRIGHTNESS

* VG DATA FOR STAR TV
VGDATA:	DC.W $7200			*SCALE BIN=2,LIN=00
	DC.W $6740			*COLOR WHT,ZSTAT=80
	DC.W $8040			*CENTER
	DC.W $0100,$6100 		*VECTOR 
	DC.W $8040 			*CENTER
	DC.W $0100,$7F00		*VECTOR
	DC.W $8040			*CENTER (2010)
	DC.W $0000,$6120 		*VECTOR
	DC.W $8040			*CENTER
	DC.W $0000,$7EF0 		*VECTOR
	DC.W $8040 			*CENTER
	DC.W $1E91,$6023 		*VECTOR (201E)
	DC.W $8040 			*CENTER
	DC.W $01F0,$6000		*VECTOR
	DC.W $8040			*CENTER
	DC.W $01A0,$60A0		*VECTOR
	DC.W $8040			*CENTER
	DC.W $0180,$7F67		*VECTOR
	DC.W $8040			*CENTER
	DC.W $2000			*HALT
*-----------------------------------------------------------------------
*Get the VG to work (Uses software timer instead of waiting for the Halt flag).
VG1:	MOVE.L	#USTACK,A7
VG1LP	CLR.W	VGRES		*Reset VG
	BSR	UP		*Upload Data
	CLR.W	VGGO		*Start VG

	MOVE.L	#-$400,D0	*Wait for VG to finish drawing (Timer)
TIMELP	ADDQ.L	#1,D0
	BNE	TIMELP

	BRA	VG1LP

*Use the VG Halt Flag.
VG2:	MOVE.L	#USTACK,A7
VG2LP	CLR.W	VGRES		*Reset VG
	BSR	UP		*Upload Data
	CLR.W	VGGO		*Start VG
	BSR	VWAIT		*Wait for VG to finish drawing (VG Flag)
	BRA	VG2LP

* In the loop, restart the VG instead of reloading from scratch.
VG3:	MOVE.L	#USTACK,A7
	CLR.W	VGRES		*Reset VG
	BSR	UP		*Upload Data
VG3LP	CLR.W	VGGO		*Start VG
	BSR	VWAIT		*Wait for VG to finish drawing
	BRA	VG3LP

* Run the VG and Read the Pots (But don't do anything with the results).
VG4:	MOVE.L	#USTACK,A7
	CLR.W	VGRES		*Reset VG
	BSR	UP		*Upload Data
VG4LP	CLR.W	VGGO		*Start VG
	BSR	VWAIT		*Wait for VG to finish drawing
	JSR	POTS		*Read the Pots
	BRA	VG4LP

* Run the VG, Read the Pots and switches, and modify the VG Data as required.
VG5:	MOVE.L	#USTACK,A7
	CLR.W	VGRES		*Reset VG
	BSR	UP		*Upload Data
VG5LP	CLR.W	VGGO		*Start VG
	BSR	VWAIT		*Wait for VG to finish drawing
	JSR	POTS		*Read the Pots
	JSR	SW		*Read the switches and modify the VG data as 
*				 required
	BRA	VG5LP

* Similar to #5 but reads the pots while the VG is going.
VG6:	MOVE.L	#USTACK,A7
	CLR.W	VGRES		*Reset VG
	BSR	UP		*Upload Data
VG6LP	CLR.W	VGGO		*Start VG
	JSR	POTS		*Read the Pots
	BSR	VWAIT		*Wait for VG to finish drawing
	JSR	SW		*Read the switches and modify the VG data as 
*				 required
	BRA	VG6LP

* Wait for VGHALT but do VG reads while waiting (to test the memory contention
* circuit).
VG7:	MOVE.L	#USTACK,A7
	CLR.W	VGRES		*Reset VG
	BSR	UP		*Upload Data
VG7LP	CLR.W	VGGO		*Start VG
	JSR	POTS		*Read the Pots
	BSR	VWAIT2		*Wait for VG to finish drawing
	JSR	SW		*Read the switches and modify the VG data as 
*				 required
	BRA	VG7LP

* TEST JSRL
VG8:	MOVE.L	#USTACK,A7
	CLR.W	VGRES		*Reset VG
	BSR	VANUP		*Upload alphanumerics

	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+			*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+			*Draw Beam Killer Box
	MOVE.W	#$8040,(A0)+			*CENTER
	MOVE.W	#$2000,(A0)+		  	*HALT

VG8LP	CLR.W	VGGO		*Start VG

	MOVE.L	#-$180,D0	*Wait for VG to finish drawing (Timer)
T8LP	ADDQ.L	#1,D0
	BNE	T8LP
	CLR.W	VGRES
	BRA	VG8LP

*Test Alphanumerics	
VG9:	MOVE.L	#USTACK,A7
	CLR.W	VGRES
	BSR	VANUP		*Upload Alphanumerics

	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+			*CENTER

	MOVE.W	#VJ_BKBOX,(A0)+			*Beam Killer Box

	MOVE.W	#$7200,(A0)+			*Standard Scale
	MOVE.W	#$0,(A0)+			*dy=0
	MOVE.W	#$1E00,(A0)+			*dx= -$200
	MOVE.W	#$7240,(A0)+			*SCALE: Bin=2, Lin=40 (To fit)
	MOVE.W	#$6730,(A0)+			*COLOR: White, Z=30
	MOVE.W	#($0A000!($3000/2)),(A0)+  	*JSRL to Alphanumerics	
	MOVE.W	#$8040,(A0)+			*CENTER

	MOVE.W	#$2000,(A0)+		  	*HALT
VG9LP	CLR.W	VGGO
	BSR	VWAIT
	BRA	VG9LP

*Test Head Up Display	
VG10:	MOVE.L	#USTACK,A7
	CLR.W	VGRES
	BSR	VANUP		*Upload Alphanumerics

	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+			*CENTER

	MOVE.W	#VJ_BKBOX,(A0)+			*Beam Killer Box

	MOVE.W	#$7200,(A0)+			*Standard Scale
	MOVE.W	#$0,(A0)+			*dy=0
	MOVE.W	#$1E00,(A0)+			*dx= -$200
	MOVE.W	#$7240,(A0)+			*SCALE: Bin=2, Lin=40 (To fit)
	MOVE.W	#$6730,(A0)+			*COLOR: White, Z=30
	MOVE.W	#($0A000!($3000/2)),(A0)+  	*JSRL to Alphanumerics	
	MOVE.W	#$8040,(A0)+			*CENTER

	MOVE.W	#VJ_TITL,(A0)+			*Head up display titles

	MOVE.W	#$7400,(A0)+			*SCALE: Bin=4, Lin=0	
	MOVE.W	#$6730,(A0)+			*COLOR: White, Z=30
	MOVE.W	#VJ_ZOOM,(A0)+			*Zoom Window

	MOVE.W	#VJ_THRUST,(A0)+
	MOVE.W 	#$8040,(A0)+

	MOVE.W	#VJ_HDN,(A0)+			*Heading
	MOVE.W	#$8040,(A0)+

	MOVE.W	#$2000,(A0)+		  	*HALT
VG10LP	CLR.W	VGGO
	BSR	VWAIT
	BRA	VG10LP

	PAGE
* Wait for VGHALT
VWAIT:	BTST	#$00,INPUTS	
	BEQ	VWAIT
	RTS

* Wait for VGHALT but do VG reads while waiting (to test the memory contention
* circuit).
VWAIT2:	
	MOVE.W	VMEM,D0
	BTST	#$00,INPUTS	
	BEQ	VWAIT2
	RTS

*Upload Alphanumerics VG Image (VGIMAGE) to VG Alphanumerics Address 
*							(VGIMAGE+VGANLOC)
VANUP:	
	MOVEA.L	#VGIMAGE,A0		*VGIMAGE  
	MOVEA.L	#VMEM+VGANLOC,A1	*VGANLOC
	MOVE.L	#$400,D0		*About 960 bytes so far	
ANLP	MOVE.W	(A0)+,(A1)+
	SUBQ.L	#2,D0
	BPL	ANLP
	RTS		

* Upload VG Data (A0) to VG (A1), D0 = counter	(30 words)
UP:	LEA.L	VGDATA,A0			
	MOVE.L	#VMEM,A1
	MOVE.B	#30,D0		*30 words
UP10	MOVE.W	(A0)+,(A1)+
	SUBQ.B	#1,D0
	BPL	UP10
	RTS

* Read the Switches, modify the VG data as required
SW:	MOVE.B	INPUTS,D0		* D0 CONTAINS SWITCH INPUTS

	BTST	#5,D0
	BNE 	SLP1
	MOVE.B 	RPOT0,VGADR1		*LEFT TRIGGER (CHANGE POSITION)
	MOVE.B	RPOT1,VGADR2

SLP1	BTST	#4,D0
	BNE	SLP2		
	MOVE.B	RPOT0,VGADR3		*RIGHT TRIGGER (LINEAR SCALE)
	MOVE.B	RPOT1,D0			
	LSR.B	#1,D0
	MOVE.B	D0,VGADR4		*	       (INTENSITY)
SLP2	RTS
*-------------------------------------------------------------------------------
	PAGE
*Test the Objects without doing any math
*SQUARE 
*(Drawing time is 880 uS for a square that fills up half the screen.)
RT1:	MOVE.L	#USTACK,A7	*Initialise stack pointer
	CLR.W 	VGRES

RT1A	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box
	MOVE.L	A0,VG_PTR		*Save the VG Pointer

	LEA.L	BOX,A2		*Load object into Point Table		
	MOVEA.W	#PTBL,A3
	MOVE.L	#8,D0		*There are 4 points in a square	
RT1B	MOVE.W	(A2)+,D1
	MOVE.W	D1,(A3)+
	SUBQ.L	#1,D0
	BNE	RT1B

	JSR	D_SQ

	MOVE.W	#$2020,(A0)	*VG Halt Instruction
	CLR.W	VGGO		*Start VG	

	BSR 	VWAIT		*Wait for VG to be done	

	BRA	RT1A
	
*ROCKET
*(Drawing time is 1.5 ms for a rocket that fills up half the screen.)
RT2:	MOVE.L	#USTACK,A7	*Initialise stack pointer
	CLR.W 	VGRES

RT2A	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box
	MOVE.L	A0,VG_PTR		*Save the VG Pointer

	LEA.L	ROCKET,A2	*Load object into Point Table
	MOVEA.W	#PTBL,A3	
	MOVE.L	#50,D0		*There are 25 points in a rocket	

RT2B	MOVE.W	Y(A2),D1
	ASL.W	#2,D1		*scale for orthographic projection
	MOVE.W	D1,X(A3)

	MOVE.W	Z(A2),D1
	ASL.W	#2,D1		*scale for orthographic projection
	MOVE.W	D1,Y(A3)

	ADDQ.L	#6,A2
	ADDQ.L	#4,A3
	SUBQ.L	#1,D0
	BNE	RT2B

	JSR	D_ROC

	MOVE.W	#$2020,(A0)	*VG Halt Instruction
	CLR.W	VGGO		*Start VG	

	BSR 	VWAIT		*Wait for VG to be done	

	BRA	RT2A
*TANK	
*(Drawing time is 1.8 ms for a tank that fills up 1/4 the screen.)
RT3:	MOVE.L	#USTACK,A7	*Initialise stack pointer
	CLR.W 	VGRES

RT3A	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box
	MOVE.L	A0,VG_PTR		*Save the VG Pointer

	LEA.L	TANK,A2		*Load object into Point Table
	MOVEA.W	#PTBL,A3	
	MOVE.L	#48,D0		*There are 24 points in a tank	

RT3B	MOVE.W	Y(A2),D1
	ASL.W	#2,D1		*scale for orthographic projection
	MOVE.W	D1,X(A3)

	MOVE.W	Z(A2),D1
	ASL.W	#2,D1		*scale for orthographic projection
	MOVE.W	D1,Y(A3)

	ADDQ.L	#6,A2
	ADDQ.L	#4,A3
	SUBQ.L	#1,D0
	BNE	RT3B

	JSR	D_TANK

	MOVE.W	#$2020,(A0)	*VG Halt Instruction
	CLR.W	VGGO		*Start VG	

	BSR 	VWAIT		*Wait for VG to be done	

	BRA	RT3A
*-------------------------------------------------------------------------------
	PAGE

*Just do the Terrain Objects
PTERR:	
*Initialise stack pointer
	MOVE.L	#USTACK,A7	
*Clear RAM, Initialise Unit Vectors, Reset VG, and Upload Alpha-Numerics 
	JSR	INIT		
*Main Loop
PTERR1	
	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box
	MOVE.L	A0,VG_PTR		*Save the VG Pointer

*UV2 is the Working Set
*	JSR 	AERO
	MOVEA.W	#UV2,A0		*Translate Ship
	MOVE.W	#$100,ZT(A0)	
	CLR.W	XT(A0)
	CLR.W	YT(A0)

*Do Terrain Objects
	CLR.W	LED1ON
	JSR	TERR
	CLR.W	LED1OFF

* Do the Horizon
	CLR.W	LED2ON
	JSR	HORIZ
	CLR.W	LED2OFF	

	MOVE.L	VG_PTR,A0
	MOVE.W	#$2020,(A0)	*VG Halt Instruction
	CLR.W	VGGO		*Start VG	

	BSR 	POTS		*Read and mediate the Pots

	BSR	TROTATE		*Rotate as requested by the Pots and Switches

*Generate the Working Copy Unit Vectors for Ship 1
	MOVE.W	#UV2,A0
	MOVE.W	#UV1,A1
	JSR 	WC_GEN		*Generate the Working Copy Unit Vectors

	BSR 	VWAIT		*Wait for VG to be done	

	BRA	PTERR1
*-------------------------------------------------------------------------------
	PAGE
* ROTATIONS FOR TEST PROGRAM
* Takes the values in POT0 and POT1 and reads Control Switches to
* Rotate the Ship.
* Takes about 440 us for three axes (for each ship)
TROTATE:
*Ship 1
*ROLL TIC
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 79 MAX
	MOVE.B	POT1,D0			*Yaw Pot
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary
	JSR	NT_YAW			* Naked Tic_Yaw

*PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 79 MAX
	MOVE.B	POT0,D0			*Pitch Pot
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary
	JSR	NT_PTCH			* Naked Tic_Pitch

*Read Trigger switches for ROLL
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary

	BTST	#04,INPUTS
	BNE	RO1
	MOVE.B	#$10,D0
	JSR	NT_ROLL			* Naked Tic Roll
	RTS

RO1	BTST	#05,INPUTS
	BNE	RO2
	MOVE.B	#-$10,D0
	JSR	NT_ROLL			* Naked Tic Roll

RO2	RTS

POTS:
* READ THE POTS
	MOVE.B	#$0,ADCON+1		*CHANNEL 0
	MOVE.B	#$8,ADCON+1		*ALE HIGH
	MOVE.B	#10,D0			*WAIT A LITTLE
P10	SUBQ.B	#1,D0
	BNE	P10
	MOVE.B	#$0,ADCON+1		*ALE LOW

	MOVE.B	#-40,D0
P20	ADDQ.B	#1,D0			*WAIT
	BNE 	P20	

	MOVE.B	ADCREAD+1,RPOT0		*READ AND STORE POT 0

	MOVE.B	#1,ADCON+1		*CHANNEL 1
	MOVE.B	#$9,ADCON+1		*ALE HIGH
	MOVE.B	#10,D0			*WAIT A LITTLE
P30	SUBQ.B	#1,D0
	BNE	P30
	MOVE.B	#1,ADCON+1		*ALE LOW

	MOVE.B	#-40,D0
P40	ADDQ.B	#1,D0			*WAIT
	BNE 	P40	

	MOVE.B	ADCREAD+1,RPOT1		*READ AND STORE POT 1

* Mediate the Pots
	MOVE.B	RPOT0,D0
	SUB.B	#$80,D0
	ASR.B	#2,D0
	MOVE.B	D0,POT0

	MOVE.B	RPOT1,D0
	NOT.B	D0
	SUB.B	#$80,D0
	ASR.B	#2,D0
	MOVE.B	D0,POT1

	RTS
	
	PAGE
* DATA LINES WALKING ONES @VMEM
TEST1:	MOVE.L	#USTACK,A7
	LEA.L	VMEM,A0			
	MOVE.L	#1,D0
T1LP	
	MOVE.W	D0,(A0)
	ROL.W	#1,D0
	BRA	T1LP	

* ADDRESS LINES 1-8 WALKING ONES @VMEM
TEST2:	MOVE.L	#USTACK,A7
	MOVE.B	#$55,D0
	MOVE.L	#VMEM,D1
	MOVE.W	#1,D1
T2LP	
	MOVE.L	D1,A0
	MOVE.B	D0,(A0)

	ROL.B	#1,D1
	BRA 	T2LP	

* WRITE TO VECTOR MEMORY
TEST3:	MOVE.L 	#VMEM,A5
	MOVE.W	#$5555,(A5)
	BRA	TEST3

* WRITE TO VECTOR MEMORY
TEST4:	MOVE.L 	#VMEM,A5
	MOVE.W	#$AAAA,(A5)
	BRA	TEST4

* LED Test
TEST5:	MOVE.L	#USTACK,A7
T5	CLR.W	LED1ON
	BSR 	WAIT
	CLR.W	LED1OFF
	CLR.W	LED2ON
	BSR 	WAIT
	CLR.W	LED2OFF
	BRA	T5

WAIT:	MOVE.L	#-65536,D0
WLP	ADDQ.L	#1,D0
	BNE	WLP
	RTS

* Test LED addressing
TEST6:	CLR.W	LED1ON
	CLR.W 	LED1OFF
	BRA	TEST6

	PAGE
*-------------------------------------------------------------------------------
*TMS-320 Test Routines
*-------------------------------------------------------------------------------
* TMS-320 Test 7
* Do ten NOPs 
* 320 program should take 3 uS @16 MHz. (/IDLE high) [2.7 uS @ 18 MHz]
* This test routine uses a timer and does not check the /IDLE flag
TEST7:	CLR.W	MRESL		*TMS-320 Reset low
	CLR.W	MRESH		*	 Reset high	
* 320 is now spinning, waiting for BIO to go high
* Load Program
	MOVEA.L	#M_320+8,A0	* Beginning of 320 Program Space

	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$0F900,(A0)+	* B $0000	Branch to $0000
	MOVE.W	#$0,(A0)+	*     "

* Start 320
	TST.W 	MBIOH
* Wait
	MOVE.B	#4,D1
T7A	SUBQ.B	#1,D1
	BNE	T7A	

DONE7	BRA	TEST7	
*--------------------------------------------------------
* TMS-320 Test 8
* Do ten NOPs 
* 320 program should take 3 uS @16 MHz. (/IDLE high) [2.7 uS @ 18 MHz]
* This test routine uses the /IDLE flag
* (All of the test routines after this will also use the /IDLE flag)
TEST8:	CLR.W	MRESL		*TMS-320 Reset low
	CLR.W	MRESH		*	 Reset high	
* 320 is now spinning, waiting for BIO to go high
* Load Program
	MOVEA.L	#M_320+8,A0	* Beginning of 320 Program Space

	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$7F80,(A0)+	* NOP
	MOVE.W	#$0F900,(A0)+	* B $0000	Branch to $0000
	MOVE.W	#$0,(A0)+	*     "

* Start 320
	TST.W 	MBIOH
* Wait
T8B	BTST	#1,IN1	
	BNE	T8B

DONE8	BRA	TEST8	
*--------------------------------------------------------
* TMS-320 Test 9
* The 320 program will: 
*	1. Copy data from Table location 20 ($180 040) to internal
* 	   Ram location 30 
*	2. Copy data from Ram location 30 to Table location 21 ($180 042)
*	3. Branch to 0, causing it to enter the Idle loop.
* The test data is taken from D0. It should appear in D1 after the test.

TEST9:	CLR.W	MRESL		*TMS-320 Reset low
	CLR.W	MRESH		*	 Reset high	
* 320 is now spinning, waiting for BIO to go high
* Load Program
	MOVEA.L	#M_320+8,A0	* Beginning of 320 Program Space

	MOVE.W	#$6E00,(A0)+	* LDPK #0	Select RAM page 0
	MOVE.W	#$7E20,(A0)+	* LACK #$20	Load ACC with $20 
	MOVE.W	#$6730,(A0)+	* TBLR $30	Table Read @ACC to RAM $30
	MOVE.W	#$7E21,(A0)+	* LACK #$21	Load ACC with $21
	MOVE.W	#$7D30,(A0)+	* TBLW $30	Table Write RAM $30 to @ACC
	MOVE.W	#$0F900,(A0)+	* B $0000	Branch to $0000
	MOVE.W	#$0,(A0)+	*     "

* Try a value
	MOVE.W	D0,M_320+$40

* Start 320
T9A	TST.W 	MBIOH

* Wait
T9B	BTST	#1,IN1	
	BNE	T9B

	MOVE.W	M_320+$42,D1
DONE9	BRA	T9A
*--------------------------------------------------------
* TMS-320 Test 10
* The 320 program will: 
*	1. Branch to the starting address of the routine (40)
*	2. Copy data from Table location 20 ($180 040) to internal
* 	   Ram location 30 
*	3. Copy data from Ram location 30 to Table location 21 ($180 042)
*	4. Branch to 0, causing it to enter the Idle loop.
* The test data is taken from D0. It should appear in D1 after the test.

TEST10:	
	CLR.W	MRESL		*TMS-320 Reset low
	CLR.W	MRESH		*	 Reset high	
* 320 is now spinning, waiting for BIO to go high
* Load Program
	MOVEA.L	#M_320+$80,A0	* Beginning of 320 Program Space (0040)

	MOVE.W	#$6E00,(A0)+	* LDPK #0	Select RAM page 0
	MOVE.W	#$7E20,(A0)+	* LACK #$20	Load ACC with $20 
	MOVE.W	#$6730,(A0)+	* TBLR $30	Table Read @ACC to RAM $30
	MOVE.W	#$7E21,(A0)+	* LACK #$21	Load ACC with $21
	MOVE.W	#$7D30,(A0)+	* TBLW $30	Table Write RAM $30 to @ACC
	MOVE.W	#$0F900,(A0)+	* B $0000	Branch to $0000
	MOVE.W	#$0,(A0)+	*     "

	MOVE.W	#$0F900,M_320+8	* B $0040
	MOVE.W	#$0040,M_320+$0A

* Try a value
	MOVE.W	D0,M_320+$40

* Start 320
T10A	TST.W 	MBIOH

* Wait
T10B	BTST	#1,IN1	
	BNE	T10B

	MOVE.W	M_320+$42,D1
DONE10	BRA	T10A
*--------------------------------------------------------
* TMS-320 Test 11 [deleted]
*--------------------------------------------------------
* TMS-320 Test 12
* Uses named variables
* The program will:
*	1. Copy data from Table location 'numera' (06; $180 00C) to internal
* 	   Ram location 06 
*	2. Copy data from Ram location 06 to Ram location 07
*	3. Copy data from Ram location 07 to Table location 'quot'(07; $180 00E)
*	4. Branch to 0, causing it to enter the Idle loop.
* The test data is taken from D0. It should appear in D1 after the test.
* [Run Test 9 first to get RAM page 0 selected ]

* TMS-320 test
TEST12:	
	CLR.W	MRESL		*TMS-320 Reset low
	CLR.W	MRESH		*	 Reset high	
* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	D0,numera

	MOVE.W	#$0F900,M_320+8
	MOVE.W	#M_TEST1,M_320+$0A

* Start 320
T12A	TST.W 	MBIOH

* Wait
T12B	BTST	#1,IN1	
	BNE	T12B

	MOVE.W	quot,D1
DONE12	BRA	DONE12
*--------------------------------------------------------
* TMS-320 Test 13
* Test the Divider #1 (Mine)
* D2 = D0/D1
TEST13:	
	JSR	INIT320		* Initialize the TMS320 
* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	D0,numera
	MOVE.W	D1,denom

	MOVE.W	#$0F900,M_320+8
	MOVE.W	#M_TEST3,M_320+$0A

* Start 320
T13A	TST.W 	MBIOH

* Wait
T13B	BTST	#1,IN1	
	BNE	T13B

	MOVE.W	quot,D2
DONE13	BRA	DONE13
*-------------------------------------------------------------------------------
* TMS-320 Test 14
* Projection
* D3 = D1/D0
* D4 = D2/D0

TEST14:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 
* 320 is now spinning, waiting for BIO to go high
* Load Data
T14A	MOVE.W	D0,m_xp

	MOVE.W	D1,m_yp		

	MOVE.W	D2,m_zp

* Set Up Branch Instruction to Projection Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_PROJ,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
T14B	BTST	#1,IN1
	BNE	T14B

	MOVE.W	m_sx,D3		*D3 = SX = K*YP/XP
	MOVE.W	m_sy,D4		*D4 = SY = K*ZP/XP

DONE14	BRA	DONE14
*-------------------------------------------------------------------------------
* TMS320 Test 15
* Download/Upload 
* Copy nine locations from Table starting at uv = 0F00 ($181E00) to UV1 in Ram
* Copy UV1 in Ram to nine locations in Table starting at m_tptr = 0F10 ($181E20)

TEST15:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
T15A	MOVE.W	#$0F00,m_uv	* Unit Vector 1 will be at $0F00 ($181E00)
	MOVE.W	#$0F10,m_tptr	* Unit Vector 2 will be at $0F10 ($181E20)

* Set Up Branch Instruction to Post1 Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_TEST2,M_PROG+2

* Start 320
	TST.W	MBIOH

* Wait for it to be done
T15B	BTST	#1,IN1
	BNE	T15B
	
DONE15	BRA	DONE15

	PAGE
*-------------------------------------------------------------------------------
* POSTADD Tests:  For M_320+$1E00 = 4000,0,0,0,4000,0,0,0,4000,100,200,300
*		      M_320+$1E20 = 4000,2000,1000
*
*			D0	D1	D2	D3	D4
*
*	Test 16		4000	2000	1000
*	Test 17		4100	2200	1300
*	Test 18		 10B	  95	4100	2200	1300
*-------------------------------------------------------------------------------
* TMS320 POSTADD2 TEST (No translation)
* Copy Unit Vectors at Table @m_uv (0F00 = M_320+$1E00) to Ram UV1
* Get x,y,z from Table @m_tptr
* Do matrix multiply
* Put result in D0, D1, D2

TEST16:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	#$0F00,m_uv	* Unit Vector 1 will be at $0F00 ($181E00)
	MOVE.W	#$0F10,m_tptr	* X,Y,Z will be at $0F10 ($181E20)

* Set Up Branch Instruction to Post1 Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_POST1,M_PROG+2

* Start 320
T16A	TST.W	MBIOH

* Wait for it to be done
T16B	BTST	#1,IN1
	BNE	T16B

	MOVE.W	m_xp,D0		
	MOVE.W	m_yp,D1		
	MOVE.W	m_zp,D2	
	
DONE16	BRA	DONE16
*-------------------------------------------------------------------------------
* TMS320 POSTADD1 TEST (with translation)
* Copy Unit Vectors at Table @m_uv (0F00 = M_320+$1E00) to Ram UV1
* Get x,y,z from Table @m_tptr
* Do matrix multiply
* Put result in D0, D1, D2

TEST17:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	#$0F00,m_uv	* Unit Vector 1 will be at $0F00 (M_320+$1E00)
	MOVE.W	#$0F10,m_tptr	* X,Y,Z will be at $0F10 (M_320+$1E20)

* Set Up Branch Instruction to Post1 Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_POST2,M_PROG+2

* Start 320
T17A	TST.W	MBIOH

* Wait for it to be done
T17B	BTST	#1,IN1
	BNE	T17B

	MOVE.W	m_xp,D0		
	MOVE.W	m_yp,D1		
	MOVE.W	m_zp,D2	
	
DONE17	BRA	DONE17
*-------------------------------------------------------------------------------
* TMS320 POSTADD3 TEST (with translation and projection)
* Copy Unit Vectors at Table @m_uv (0F00 = M_320+$1E00) to Ram UV1
* Get x,y,z from Table @m_tptr
* Do matrix multiply
* Do post translation
* Do Projection
* Put m_sx, m_sy in D0, D1
* Put m_xp, m_yp, m_zp in D2, D3, D4

TEST18:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	#$0F00,m_uv	* Unit Vector 1 will be at $0F00 (M_320+$1E00)
	MOVE.W	#$0F10,m_tptr	* X,Y,Z will be at $0F10 ($M_320+$1E20)

* Set Up Branch Instruction to Post1 Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_POST3,M_PROG+2

* Start 320
T18A	TST.W	MBIOH

* Wait for it to be done
T18B	BTST	#1,IN1
	BNE	T18B

	MOVE.W	m_sx,D0		
	MOVE.W	m_sy,D1		

	MOVE.W	m_xp,D2		
	MOVE.W	m_yp,D3		
	MOVE.W	m_zp,D4	
	
DONE18	BRA	DONE18
*-------------------------------------------------------------------------------
* TMS320 CONCAT
* Copy Unit Vectors at Table @m_uv (0F00 = M_320+$1E00) to Ram UV1

* CCUV = UV1(UV) * [UV2(TPTR)]^

TEST19:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	#(m_uv1-M_320)/2,m_uv		
	MOVE.W	#(m_uv2-M_320)/2,m_tptr		

* Set Up Branch Instruction to Post1 Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_CONCAT,M_PROG+2

* Start 320
T19A	TST.W	MBIOH

* Wait for it to be done
T19B	BTST	#1,IN1
	BNE	T19B

DONE19	BRA	DONE19
*-------------------------------------------------------------------------------
	PAGE
* TMS320 ROLL
* ROLL Unit Vectors at Table @m_uv 
*
*	Ay' = Ay*Cos - Az*Sin
*	Az' = Ay*Sin + Az*Cos
*
*	By' = By*Cos - Bz*Sin
*	Bz' = By*Sin + Bz*Cos
*
*	Cy' = Cy*Cos - Cz*Sin
*	Cz' = Cy*Sin + Cz*Cos
*
*
*
* For	Sin = 0, Cos = 4000, the matrix is unchanged.
* For 	Sin=4000, Cos = 0
*------------------------------------
*	 111     222     333
*
*	 444     555	 666
*
*	 777	 888	 999
*------------------------------------
*	 111     222     333
*
*	-777    -888    -999
*	(F889)  (F778)  (F667)
*
*	 444     555     666
*------------------------------------
*	 111     222     333
*
*	-444    -555    -666
*	(FBBC) 	(FAAB)	(F99A)
*
*	-777    -888    -999
*	(F889)  (F778)  (F667)
*------------------------------------
*	 111     222     333
*
*	 777	 888	 999
*
*	-444    -555    -666
*	(FBBC) 	(FAAB)	(F99A)
*------------------------------------
*	 111     222     333
*
*	 444     555	 666
*
*	 777	 888	 999
*------------------------------------
TEST20:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	#(m_ccuv-M_320)/2,m_uv	
	MOVE.W	D0,m_sin
	MOVE.W	D1,m_cos

* Set Up Branch Instruction to Roll Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_ROLL,M_PROG+2

* Start 320
T20A	TST.W	MBIOH

* Wait for it to be done
T20B	BTST	#1,IN1
	BNE	T20B

DONE20	BRA	DONE20
*-------------------------------------------------------------------------------
* TMS320 PRESUB TEST 
* Copy Unit Vectors at Table @m_uv (0F00 = M_320+$1E00) to Ram UV1
* Get x,y,z from Table @m_tptr
* Do matrix multiply
* Put result in D0, D1, D2

TEST21:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	#$0F00,m_uv	* Unit Vector 1 will be at $0F00 (M+320+$1E00)
	MOVE.W	#$0F10,m_tptr	* X,Y,Z will be at $0F10 (M_320+$1E20)

* Set Up Branch Instruction to Post1 Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#M_PRESUB,M_PROG+2

* Start 320
T21A	TST.W	MBIOH

* Wait for it to be done
T21B	BTST	#1,IN1
	BNE	T21B

	MOVE.W	m_xp,D0		
	MOVE.W	m_yp,D1		
	MOVE.W	m_zp,D2	
	
DONE21	BRA	DONE21
*-------------------------------------------------------------------------------
* TMS320 CLIPPING TESTS

TEST22:	
	MOVE.W	#USTACK,A7	* Initialize the stack pointer
	JSR	INIT320		* Initialize the TMS320 

* 320 is now spinning, waiting for BIO to go high
* Load Data
	MOVE.W	D0,m_x1
	MOVE.W	D1,m_y1
	MOVE.W	D2,m_z1
	MOVE.W	D3,m_x2
	MOVE.W	D4,m_y2
	MOVE.W	D5,m_z2

* Set Up Branch Instruction to Post1 Routine
	MOVE.W	#$0F900,M_PROG	
	MOVE.W	#$0000,M_PROG+2		* CLIP2 is not currently in microcode

* Start 320
T22A	TST.W	MBIOH

* Wait for it to be done
T22B	BTST	#1,IN1
	BNE	T22B
	
	MOVE.W	m_x1,A0
	MOVE.W	m_y1,A1
	MOVE.W	m_z1,A2
		
	MOVE.W	m_x2,A3
	MOVE.W	m_y2,A4
	MOVE.W	m_z2,A5

	MOVE.W	m_xp,D6
		
DONE22	BRA	DONE22
*-------------------------------------------------------------------------------
	PAGE
SWITCH	SET	0

	IFNE	SWITCH
	XDEF	RDNL,CDNL,TDNL
*Download Object - Cube
* M_OBJ is at tms320 address 0E00 = M_320+$1C00 
CDNL:	
	LEA.L	CUBE,A0		* source
	LEA.L	M_OBJ,A1	* destination
	MOVE.L	#(8*3-1),D0	* 8 points * 3 words -1 for loop
CLP:	MOVE.W	(A0)+,(A1)+
	DBF	D0,CLP
	RTS
	
*Download Object - Rocket
* M_OBJ is at tms320 address 0E00 = M_320+$1C00 
RDNL:	
	LEA.L	ROCKET,A0	* source
	LEA.L	M_OBJ,A1	* destination
	MOVE.W	#(25*3-1),D0	* 25 points * 3 words -1 for loop
RLP:	MOVE.W	(A0)+,(A1)+
	DBF	D0,RLP

* Download the grid
	LEA.L	GRLINE,A0	* source
	LEA.L	M_GRID,A1	* destination
	MOVE.W	#(22*2*3-1),D0	* 22 lines * 2 points * 3 words -1 for loop
GDLP:	MOVE.W	(A0)+,(A1)+
	DBF	D0,GDLP

	RTS
	
*Download Object - Tank
* M_OBJ is at tms320 address 0E00 = M_320+$1C00 
TDNL:	
	LEA.L	TANK,A0	* source
	LEA.L	M_OBJ,A1	* destination
	MOVE.W	#(24*3-1),D0	* 24 points * 3 words -1 for loop
TLP:	MOVE.W	(A0)+,(A1)+
	DBF	D0,TLP
	RTS

	ENDC
*-------------------------------------------------------------------------------
	PAGE
* Download Pictures into 320 RAM


* Eventually even this will be replaced by a fixed list

DNLOBJ:	MACRO
	XDEF	M_\1
M_\1	EQU	(M_PTR-M_320)/2		* Address in TMS-320
	LEA.L	\1,A0			* source
	MOVE.L	#(\2*3-1),D0		*  #points * 3 words -1 for loop
\@:	MOVE.W	(A0)+,(A1)+
	DBF	D0,\@
M_PTR	SET	M_PTR+(\2*3*2)		* increment pointer by #bytes
	ENDM

*Download Objects, starting at M_OBJ
DOWN320:
M_PTR	SET	M_OBJ			* Objects start at M_OBJ
	LEA.L	M_PTR,A1	 

	DNLOBJ	ROCKET,25
	DNLOBJ	GRLINE,44
	DNLOBJ	STARS,32
	DNLOBJ	CUBE,8
	DNLOBJ	TANK,24
	DNLOBJ	AIR,24
	DNLOBJ	SAUCER,17

	RTS	

* ROCKET 25 + GRID 44 + STARS 32 + CUBE 8 + TANK 24 + AIR 24  
*			= 157 POINTS * 3 WORDS = 471 WORDS
*	+ SAUCER 17 * 3 words =  622
*-------------------------------------------------------------------------------
	PAGE
* Look at (and rotate) individual objects

	XDEF RTBL,LCUBE,LTANK,LROC,LAIR,LSAU,LHIND
	XDEF LRESU,LMLOOP,DO_OBJ

RED	EQU	4
GREEN	EQU	2
BLUE	EQU	1

	XREF D_CUBE,D_SQ,D_TANK,D_ROC,D_AIR,D_SAU,D_BUZZ,D_HIND,D_CITY
	XREF NT_ROLL,NT_PTCH,NT_YAW,NWC_GEN,NCONCAT,NPOST

RTBL:	
	DC.L	CUBE,D_CUBE,8
	DC.B	RED,$40

	DC.L	ROCKET,D_ROC,25
	DC.B	BLUE,$40

	DC.L	TANK,D_TANK,24
	DC.B	GREEN,$40

	DC.L	AIR,D_AIR,24
	DC.B	BLUE,$40

	DC.L	SAUCER,D_SAU,17
	DC.B	GREEN,$40

	DC.L	HIND,D_HIND,54
	DC.B	RED,$40

* Rotate the Objects to see what they look like, using only 68010

LCUBE:	MOVE.W	#0,D0
	BRA	LRESU
LROC:	MOVE.W	#1,D0
	BRA	LRESU
LTANK:	MOVE.W	#2,D0
	BRA	LRESU
LAIR:	MOVE.W	#3,D0
	BRA	LRESU
LSAU:	MOVE.W	#4,D0
	BRA	LRESU
LHIND:	MOVE.W	#5,D0
	BRA	LRESU

LRESU:	MOVE.L	#USTACK,A7	*Initialise stack pointer
	MOVE.W 	#$2F00,SR	*Disable Interrupts

* Convert Model Number into Table Address
	MULU	#14,D0		
	LEA.L	RTBL,A0
	ADDA.W	D0,A0
	MOVE.L	A0,MODEL
* Initialise Unit Vectors, Reset VG, and Upload Alpha-Numerics 
	JSR	INITB		

*Main Loop
LMLOOP	
	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box
	MOVE.L	A0,VG_PTR		*Save the VG Pointer

	MOVEA.W	#CCUV,A0	*Concatenate Unit Vectors
	MOVEA.W	#UV2,A2		*UV2 is the working copy (Ship)
	MOVEA.W	#UV3,A1		*UV3 is currently the identity matrix (Observer)
	JSR	NCONCAT		*Ship in A1 looks at Ship in A2 (Naked)

	MOVEA.W	#CCUV,A0	*Translate Ship
	MOVE.W	#$100,XT(A0)	
	CLR.W	YT(A0)
	CLR.W	ZT(A0)

	BSR	DO_OBJ		*Do the selected object

	MOVE.W	#$2020,(A0)	*VG Halt Instruction
	CLR.W	VGGO		*Start VG	

	BSR 	POTS		*Read and mediate the Pots

	BSR	TROTATE		*Rotate as requested by the Pots and Switches

*Generate the Working Copy Unit Vectors for Ship 1
	MOVE.W	#UV2,A0
	MOVE.W	#UV1,A1
	JSR 	NWC_GEN		* Generate the Working Copy (Naked)

	BSR 	VWAIT		*Wait for VG to be done	

	BRA	LMLOOP

*---
DO_OBJ:
	MOVE.L	MODEL,A3	* Model Select Table Data, 

	MOVEA.W #CCUV,A0	*Post Add Transform CCUV to Point Table
	MOVE.L	(A3),A1		* 0(A1) is address of Object Picture (ex. CUBE)
	MOVEA.W	#PTBL,A2	* Put Projected points in the Point Table
	MOVE.L	8(A3),D5	* Number of Points (ex. '8')
	JSR	NPOST		* Post Add and Project

	MOVE.L	MODEL,A3
	MOVE.B	12(A3),COLOR
	MOVE.B	13(A3),BRITE
	MOVE.L	4(A3),A3
	JSR	(A3)		* Drawing Routine (ex. 'D_CUBE')
	RTS
*-------------------------------------------------------------------------------
	END
* (OLD STUFF)

	XDEF RESUME,RT1,RT2,RT3
	XDEF PCUBE,PTANK,PROC,PTERR

* Rotate the Objects to see what they look like
PCUBE:	LEA.L	DO_CUBE,A0	*Show the Picture of the Cube
	MOVE.L	A0,MODEL

	BRA 	RESUME

PTANK:	LEA.L	DO_TANK,A0	*Show the Picture of the Tank
	MOVE.L	A0,MODEL

	BRA 	RESUME

PROC:	LEA.L	DO_ROC,A0	*Show the Picture of the Rocket
	MOVE.L	A0,MODEL

	BRA 	RESUME

RESUME:	MOVE.L	#USTACK,A7	*Initialise stack pointer
	MOVE.W 	#$2F00,SR	*Disable Interrupts

* Initialise Unit Vectors, Reset VG, and Upload Alpha-Numerics 
	JSR	INITB		

* Download the objects into the 320 RAM
*	BSR	DOWN320

*Main Loop
MLOOP	
	MOVEA.L	#VMEM,A0
	MOVE.W	#$8040,(A0)+		*CENTER
	MOVE.W	#VJ_BKBOX,(A0)+		*Beam Killer Box
	MOVE.L	A0,VG_PTR		*Save the VG Pointer

	MOVEA.W	#CCUV,A0	*Concatenate Unit Vectors
	MOVEA.W	#UV2,A2		*UV2 is the working copy (Ship)
	MOVEA.W	#UV3,A1		*UV3 is currently the identity matrix (Observer)
	JSR	NCONCAT		*Ship in A1 looks at Ship in A2 (Naked)

	MOVEA.W	#CCUV,A0	*Translate Ship
	MOVE.W	#$100,XT(A0)	
	CLR.W	YT(A0)
	CLR.W	ZT(A0)

	MOVE.L	MODEL,A0	*Do the selected object
	JSR	(A0)

	MOVE.W	#$2020,(A0)	*VG Halt Instruction
	CLR.W	VGGO		*Start VG	

	BSR 	POTS		*Read and mediate the Pots

	BSR	TROTATE		*Rotate as requested by the Pots and Switches

*Generate the Working Copy Unit Vectors for Ship 1
	MOVE.W	#UV2,A0
	MOVE.W	#UV1,A1
	JSR 	NWC_GEN		* Generate the Working Copy (Naked)

	BSR 	VWAIT		*Wait for VG to be done	

	BRA	MLOOP

DO_CUBE: 
	MOVEA.W #CCUV,A0	*Post Add Transform CCUV to Point Table
	LEA.L	CUBE,A1		*Ship 1 is a Cube
	MOVEA.W	#PTBL,A2	*Put Projected points in the Point Table

* This is where the Cube is in the 320 RAM
*	MOVE.W	#M_CUBE,m_tptr   

	MOVE.L	#8,D5		*There are 8 points in the Cube
	JSR	NPOST
	JSR	D_CUBE		*Draw the Cube
	RTS

DO_ROC:	
	MOVEA.W	#CCUV,A0	*Post Add Transform CCUV to Point Table
	LEA.L	ROCKET,A1	*Ship 1 is a Rocket
	MOVEA.W	#PTBL,A2	*Put Projected points in the Point Table

* This is where the Rocket is in the 320 RAM
*	MOVE.W	#M_ROCKET,m_tptr   

	MOVE.L	#25,D5		*There are 25 points in the Rocket
	JSR	NPOST
	MOVE.B	#$40,BRITE
	JSR	D_ROC		*Draw the Rocket
	RTS

DO_TANK: 
	MOVEA.W #CCUV,A0	*Post Add Transform CCUV to Point Table
	LEA.L	TANK,A1		*Ship 1 is a Tank
	MOVEA.W	#PTBL,A2	*Put Projected points in the Point Table

* This is where the Tank is in the 320 RAM
*	MOVE.W	#M_TANK,m_tptr

	MOVE.L	#24,D5		*There are 24 points in the Tank
	JSR	NPOST
	JSR	D_TANK		*Draw the Tank
	RTS
*-------------------------------------------------------------------------------
